# How to cross-swap tokens with min out required amount?

{% hint style="warning" %}

* Fees will be taken on each hoop
* Minimum amount defined in min units (4.0000 USDT = 40000)
* Amount out will be greater or equal to min units in the memo
* Both token balances should be opened
  {% endhint %}

{% tabs %}
{% tab title="@a-dex/a-dex-sdk" %}

```typescript
import {
  SwapActionGenerator,
  SwapTransactionGenerator,
} from "@a-dex/a-dex-sdk";
import { ExtendedAsset, Name, Asset } from "eos-common";

const actionsGen = new SwapActionGenerator("swap.adex");
const trxGen = new SwapTransactionGenerator(
  [
    {
      actor: "trader.adex",
      permission: "active",
    },
  ],
  actionsGen
);

const trx = await trxGen.swapWithMinReceived(
    new Name("trader.adex"),
    new ExtendedAsset(new Asset("1.0000 EOS"), new Name("eosio.token")),
    new ExtendedAsset(new Asset("4.0000 USDT"), new Name("tethertether")),
    "1-2-3"
  );

```

{% endtab %}

{% tab title="cleos" %}

```bash
cleos -u https://eos.greymass.com push transaction '{
  "delay_sec": 0,
  "max_cpu_usage_ms": 0,
  "actions": [
    {
      "account": "eosio.token",
      "name": "transfer",
      "data": {
        "from": "trader.adex",
        "to": "swap.adex",
        "quantity": "1.0000 EOS",
        "memo": "swap:1-3;min:40000"
      },
      "authorization": [
        {
          "actor": "trader.adex",
          "permission": "active"
        }
      ]
    }
  ]
}'
```

{% endtab %}

{% tab title="eosjs" %}

```javascript
const result = await api.transact({
  actions: [{
    account: 'eosio.token',
    name: 'transfer',
    authorization: [{
      actor: 'trader.adex',
      permission: 'active',
    }],
    data: {
      from: 'trader.adex',
      to: 'swap.adex',
      quantity: '1.0000 EOS',
      memo: 'swap:1-3;min:40000'
    },
  }]
}, {
  blocksBehind: 3,
  expireSeconds: 30,
});
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.a-dex.io/developers/smart-contracts/swap/examples/how-to-cross-swap-tokens-with-min-out-required-amount.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
